Implement diskimage_is-file() for loopback and guestfish.
[autocluster.git] / autocluster
1 #!/bin/bash
2 # main autocluster script
3 #
4 # Copyright (C) Andrew Tridgell  2008
5 # Copyright (C) Martin Schwenke  2008
6 #
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 3 of the License, or
10 # (at your option) any later version.
11 #   
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #   
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, see <http://www.gnu.org/licenses/>.
19
20 ##BEGIN-INSTALLDIR-MAGIC##
21 # There are better ways of doing this but not if you still want to be
22 # able to run straight out of a git tree.  :-)
23 if [ -f "$0" ]; then
24     installdir="`dirname \"$0\"`"
25 else
26     autocluster=`which $0`
27     installdir="`dirname \"$autocluster\"`"
28 fi
29 ##END-INSTALLDIR-MAGIC##
30
31 ####################
32 # show program usage
33 usage ()
34 {
35     cat <<EOF
36 Usage: autocluster [OPTION] ... <COMMAND>
37   options:
38      -c <file>                   specify config file (default is "config")
39 EOF
40
41     releases=$(list_releases)
42
43     usage_smart_display \
44         defconf "WITH_RELEASE" "" \
45         "<string>" "specify preset options for a release using a version string.  Possible values are: ${releases}."
46
47 cat <<EOF
48      -e <expr>                   execute <expr> and exit
49      -E <expr>                   execute <expr> and continue
50      -x                          enable script debugging
51      --dump                      dump config settings and exit
52
53   configuration options:
54 EOF
55
56     usage_config_options
57
58     cat <<EOF
59
60   commands:
61      create base
62            create a base image
63
64      create cluster CLUSTERNAME
65            create a full cluster
66
67      create node CLUSTERNAME IP_OFFSET
68            (re)create a single cluster node
69
70      mount DISK
71            mount a qemu disk on mnt/
72
73      unmount
74            unmount a qemu disk from mnt/
75
76      bootbase
77            boot the base image
78
79      testproxy
80            test your proxy setup
81 EOF
82     exit 1
83 }
84
85 ###############################
86
87 die () {
88     fill_text 0 "ERROR: $*" >&2
89     exit 1
90 }
91
92 ###############################
93
94 # Indirectly call a function named by ${1}_${2}
95 call_func () {
96     local __func="$1" ; shift
97     local __type="$1" ; shift
98
99     local f="${__func}_${__type}"
100     if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null ; then
101         "$f" "$@"
102     else
103         f="${__func}_DEFAULT"
104         if type -t "$f" >/dev/null && ! type -P "$f" >/dev/null  ; then
105             "$f" "$__type" "$@"
106         else
107             die "No function defined for \"${__func}\" \"${__type}\""
108         fi
109     fi
110 }
111
112 # Note that this will work if you pass "call_func f" because the first
113 # element of the node tuple is the node type.  Nice...  :-)
114 for_each_node ()
115 {
116     local n
117     for n in $NODES ; do
118         "$@" $(IFS=: ; echo $n)
119     done
120 }
121
122 hack_one_node_with ()
123 {
124     local filter="$1" ; shift
125
126     local node_type="$1"
127     local ip_offset="$2"
128     local name="$3"
129     local ctdb_node="$4"
130
131     $filter
132
133     local item="${node_type}:${ip_offset}${name:+:}${name}${ctdb_node:+:}${ctdb_node}"
134     nodes="${nodes}${nodes:+ }${item}"
135 }
136
137 # This also gets used for non-filtering iteration.
138 hack_all_nodes_with ()
139 {
140     local filter="$1"
141
142     local nodes=""
143     for_each_node hack_one_node_with "$filter"
144     NODES="$nodes"
145 }
146
147 register_hook ()
148 {
149     local hook_var="$1"
150     local new_hook="$2"
151
152     eval "$hook_var=\"${!hook_var}${!hook_var:+ }${new_hook}\""
153 }
154
155 run_hooks ()
156 {
157     local hook_var="$1"
158
159     local i
160     for i in ${!hook_var} ; do
161         $i
162     done
163 }
164
165 # Use with care, since this may clear some autocluster defaults.!
166 clear_hooks ()
167 {
168     local hook_var="$1"
169
170     eval "$hook_var=\"\""
171 }
172
173 ##############################
174
175 # common node creation stuff
176 create_node_COMMON ()
177 {
178     local NAME="$1"
179     local ip_offset="$2"
180     local type="$3"
181     local template_file="${4:-$NODE_TEMPLATE}"
182
183     if [ "$SYSTEM_DISK_FORMAT" != "qcow2" -a "$BASE_FORMAT" = "qcow2" ] ; then
184         die "Error: if BASE_FORMAT is \"qcow2\" then SYSTEM_DISK_FORMAT must also be \"qcow2\"."
185     fi
186
187     IPNUM=$(($FIRSTIP + $ip_offset))
188     DISK="${VIRTBASE}/${CLUSTER}/${NAME}.${SYSTEM_DISK_FORMAT}"
189     local base_disk="${VIRTBASE}/${BASENAME}.${BASE_FORMAT}"
190
191     if [ "$BASE_PER_NODE_TYPE" = "yes" ] ; then
192         base_disk="${VIRTBASE}/${BASENAME}-${type}.${BASE_FORMAT}"
193     fi
194
195     mkdir -p $VIRTBASE/$CLUSTER tmp
196
197     rm -f "$DISK"
198     case "$SYSTEM_DISK_FORMAT" in
199         qcow2)
200             echo "Creating the disk..."
201             qemu-img create -b "$base_disk" -f qcow2 "$DISK"
202             create_node_configure_image "$DISK" "$type"
203             ;;
204         raw)
205             echo "Creating the disk..."
206             cp -v --sparse=always "$base_disk" "$DISK"
207             create_node_configure_image "$DISK" "$type"
208             ;;
209         reflink)
210             echo "Creating the disk..."
211             cp -v --reflink=always "$base_disk" "$DISK"
212             create_node_configure_image "$DISK" "$type"
213             ;;
214         none)
215             echo "Skipping disk image creation as requested"
216             ;;
217         *)
218             die "Error: unknown SYSTEM_DISK_FORMAT=\"${SYSTEM_DISK_FORMAT}\"."
219     esac
220
221     set_macaddrs $CLUSTER $ip_offset
222
223     # Pull the UUID for this node out of the map.
224     UUID=$(awk "\$1 == $ip_offset {print \$2}" $uuid_map)
225     
226     echo "Creating $NAME.xml"
227     substitute_vars $template_file tmp/$NAME.xml
228     
229     # install the XML file
230     $VIRSH undefine $NAME > /dev/null 2>&1 || true
231     $VIRSH define tmp/$NAME.xml
232 }
233
234 create_node_configure_image ()
235 {
236     local disk="$1"
237     local type="$2"
238
239     diskimage_mount "$disk"
240     setup_base "$type"
241     diskimage_unmount
242 }
243
244 # Provides an easy way of removing nodes from $NODE.
245 create_node_null () {
246     :
247 }
248
249 ##############################
250
251 hack_nodes_functions=
252
253 expand_nodes () {
254     # Expand out any abbreviations in NODES.
255     local ns=""
256     local n
257     for n in $NODES ; do
258         local t="${n%:*}"
259         local ips="${n#*:}"
260         case "$ips" in
261             *,*)
262                 local i
263                 for i in ${ips//,/ } ; do
264                     ns="${ns}${ns:+ }${t}:${i}"
265                 done
266                 ;;
267             *-*)
268                 local i
269                 for i in $(seq ${ips/-/ }) ; do
270                     ns="${ns}${ns:+ }${t}:${i}"
271                 done
272                 ;;
273             *)
274                 ns="${ns}${ns:+ }${n}"
275         esac
276     done
277     NODES="$ns"
278
279     # Apply nodes hacks.  Some of this is about backward compatibility
280     # but the hacks also fill in the node names and whether they're
281     # part of the CTDB cluster.  The order is the order that
282     # configuration modules register their hacks.
283     run_hooks hack_nodes_functions
284
285     if [ -n "$NUMNODES" ] ; then
286         # Attempt to respect NUMNODES.  Reduce the number of CTDB
287         # nodes to NUMNODES.
288         local numnodes=$NUMNODES
289
290         hack_filter ()
291         {
292             if [ "$ctdb_node" = 1 ] ; then
293                 if [ $numnodes -gt 0 ] ; then
294                     numnodes=$(($numnodes - 1))
295                 else
296                     node_type="null"
297                     ctdb_node=0
298                 fi
299             fi
300         }
301
302         hack_all_nodes_with hack_filter
303                         
304         [ $numnodes -gt 0 ] && \
305             die "Can't not use NUMNODES to increase the number of nodes over that specified by NODES.  You need to set NODES instead - please read the documentation."
306     fi
307     
308     # Check IP addresses for duplicates.
309     local ip_offsets=":"
310     # This function doesn't modify anything...
311     get_ip_offset ()
312     {
313         [ "${ip_offsets/${ip_offset}}" != "$ip_offsets" ] && \
314             die "Duplicate IP offset in NODES - ${node_type}:${ip_offset}"
315         ip_offsets="${ip_offsets}${ip_offset}:"
316     }
317     hack_all_nodes_with get_ip_offset
318 }
319
320 ##############################
321
322 sanity_check_cluster_name ()
323 {
324     [ -z "${CLUSTER//[A-Za-z0-9]}" ] || \
325         die "Cluster names should be restricted to the characters A-Za-z0-9.  \
326 Some cluster filesystems have problems with other characters."
327 }
328
329 hosts_file=
330
331 common_nodelist_hacking ()
332 {
333     # Rework the NODES list
334     expand_nodes
335
336     # Build /etc/hosts and hack the names of the ctdb nodes
337     hosts_line_hack_name ()
338     {
339         # Ignore nodes without names (e.g. "null")
340         [ "$node_type" != "null" -a -n "$name" ] || return 0
341
342         local sname=""
343         local hosts_line
344         local ip_addr="$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
345         
346         if [ "$ctdb_node" = 1 ] ; then
347             num_ctdb_nodes=$(($num_ctdb_nodes + 1))
348             sname="${CLUSTER}n${num_ctdb_nodes}"
349             hosts_line="$ip_addr ${sname}.${ld} ${name}.${ld} $name $sname"
350             name="$sname"
351         else
352             hosts_line="$ip_addr ${name}.${ld} $name"
353         fi
354
355         # This allows you to add a function to your configuration file
356         # to modify hostnames (and other aspects of nodes).  This
357         # function can access/modify $name (the existing name),
358         # $node_type and $ctdb_node (1, if the node is a member of the
359         # CTDB cluster, 0 otherwise).
360         if [ -n "$HOSTNAME_HACKING_FUNCTION" ] ; then
361             local old_name="$name"
362             $HOSTNAME_HACKING_FUNCTION
363             if [ "$name" != "$old_name" ] ; then
364                 hosts_line="$ip_addr ${name}.${ld} $name"
365             fi
366         fi
367
368         echo "$hosts_line"
369     }
370     hosts_file="tmp/hosts.$CLUSTER"
371     {
372         local num_ctdb_nodes=0
373         local ld=$(echo $DOMAIN | tr A-Z a-z)
374         echo "# autocluster $CLUSTER"
375         hack_all_nodes_with hosts_line_hack_name
376         echo
377     } >$hosts_file
378
379     # Build /etc/ctdb/nodes
380     ctdb_nodes_line ()
381     {
382         [ "$ctdb_node" = 1 ] || return 0
383         echo "$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
384         num_nodes=$(($num_nodes + 1))
385     }
386     nodes_file="tmp/nodes.$CLUSTER"
387     local num_nodes=0
388     hack_all_nodes_with ctdb_nodes_line >$nodes_file
389     : "${NUMNODES:=${num_nodes}}"  # Set $NUMNODES if necessary
390
391     # Build UUID map
392     uuid_map="tmp/uuid_map.$CLUSTER"
393     uuid_map_line ()
394     {
395         echo "${ip_offset} $(uuidgen) ${node_type}"
396     }
397     hack_all_nodes_with uuid_map_line >$uuid_map
398 }
399
400 create_cluster_hooks=
401 cluster_created_hooks=
402
403 create_cluster ()
404 {
405     CLUSTER="$1"
406
407     sanity_check_cluster_name
408
409     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
410
411     # Run hooks before doing anything else.
412     run_hooks create_cluster_hooks
413
414     common_nodelist_hacking
415
416     for_each_node call_func create_node
417
418     echo "Cluster $CLUSTER created"
419     echo ""
420
421     run_hooks cluster_created_hooks
422 }
423
424 cluster_created_hosts_message ()
425 {
426     echo "You may want to add this to your /etc/hosts file:"
427     cat $hosts_file
428 }
429
430 register_hook cluster_created_hooks cluster_created_hosts_message
431
432 create_one_node ()
433 {
434     CLUSTER="$1"
435     local single_node_ip_offset="$2"
436
437     sanity_check_cluster_name
438
439     mkdir -p $VIRTBASE/$CLUSTER $KVMLOG tmp
440
441     common_nodelist_hacking
442
443     for n in $NODES ; do
444         set -- $(IFS=: ; echo $n)
445         [ $single_node_ip_offset -eq $2 ] || continue
446         call_func create_node "$@"
447         
448         echo "Requested node created"
449         echo ""
450         echo "You may want to update your /etc/hosts file:"
451         cat $hosts_file
452         
453         break
454     done
455 }
456
457 ###############################
458 # test the proxy setup
459 test_proxy() {
460     export http_proxy=$WEBPROXY
461     wget -O /dev/null $INSTALL_SERVER || \
462         die "Your WEBPROXY setting \"$WEBPROXY\" is not working"
463     echo "Proxy OK"
464 }
465
466 ###################
467
468 kickstart_floppy_create_hooks=
469
470 # create base image
471 create_base() {
472
473     NAME="$BASENAME"
474     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
475
476     mkdir -p $KVMLOG
477
478     echo "Testing WEBPROXY $WEBPROXY"
479     test_proxy
480
481     echo "Creating the disk"
482     qemu-img create -f $BASE_FORMAT "$DISK" $DISKSIZE
483
484     rm -rf tmp
485     mkdir -p mnt tmp tmp/ISO
486
487     setup_timezone
488
489     echo "Creating kickstart file from template"
490     substitute_vars "$KICKSTART" "tmp/ks.cfg"
491
492     if [ $INSTALLKEY = "--skip" ]; then
493         cat <<EOF
494 --------------------------------------------------------------------------------------
495 WARNING: You have not entered an install key. Some RHEL packages will not be installed.
496
497 Please enter a valid RHEL install key in your config file like this:
498
499   INSTALLKEY="1234-5678-0123-4567"
500
501 The install will continue without an install key in 5 seconds
502 --------------------------------------------------------------------------------------
503 EOF
504         sleep 5
505     fi
506
507     # $ISO gets $ISO_DIR prepended if it doesn't start with a leading '/'.
508     case "$ISO" in
509         (/*) : ;;
510         (*) ISO="${ISO_DIR}/${ISO}"
511     esac
512     
513     echo "Creating kickstart floppy"
514     dd if=/dev/zero of=tmp/floppy.img bs=1024 count=1440
515     mkdosfs tmp/floppy.img
516     mount -o loop -t msdos tmp/floppy.img mnt
517     cp tmp/ks.cfg mnt
518     mount -o loop,ro $ISO tmp/ISO
519     
520     echo "Setting up bootloader"
521     cp tmp/ISO/isolinux/isolinux.bin tmp
522     cp tmp/ISO/isolinux/vmlinuz tmp
523     cp tmp/ISO/isolinux/initrd.img tmp
524
525     run_hooks kickstart_floppy_create_hooks
526
527     umount tmp/ISO
528     umount mnt
529
530     UUID=`uuidgen`
531
532     substitute_vars $INSTALL_TEMPLATE tmp/$NAME.xml
533
534     rm -f $KVMLOG/serial.$NAME
535
536     # boot the install CD
537     $VIRSH create tmp/$NAME.xml
538
539     echo "Waiting for install to start"
540     sleep 2
541     
542     # wait for the install to finish
543     if ! waitfor $KVMLOG/serial.$NAME "$KS_DONE_MESSAGE" $CREATE_BASE_TIMEOUT ; then
544         $VIRSH destroy $NAME
545         die "Failed to create base image $DISK"
546     fi
547     
548     $VIRSH destroy $NAME
549
550     ls -l $DISK
551     cat <<EOF
552
553 Install finished, base image $DISK created
554
555 You may wish to run
556    chattr +i $DISK
557 To ensure that this image does not change
558
559 Note that the root password has been set to $ROOTPASSWORD
560
561 EOF
562 }
563
564 ###############################
565 # boot the base disk
566 boot_base() {
567     CLUSTER="$1"
568
569     NAME="$BASENAME"
570     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
571
572     rm -rf tmp
573     mkdir -p tmp
574
575     IPNUM=$FIRSTIP
576     CLUSTER="base"
577
578     diskimage_mount $DISK
579     setup_base
580     diskimage_unmount
581
582     UUID=`uuidgen`
583     
584     echo "Creating $NAME.xml"
585     substitute_vars $BOOT_TEMPLATE tmp/$NAME.xml
586     
587     # boot the base system
588     $VIRSH create tmp/$NAME.xml
589 }
590
591 ######################################################################
592
593 # various functions...
594
595 # Set some MAC address variables based on a hash of the cluster name
596 # plus the node number and each adapter number.
597 set_macaddrs () {
598     local cname="$1"
599     local ip_offset="$2"
600
601     local md5=$(echo $cname | md5sum)
602     local nh=$(printf "%02x" $ip_offset)
603     local mac_prefix="02:${md5:0:2}:${md5:2:2}:00:${nh}:"
604
605     MAC1="${mac_prefix}01"
606     MAC2="${mac_prefix}02"
607     MAC3="${mac_prefix}03"
608     MAC4="${mac_prefix}04"
609     MAC5="${mac_prefix}05"
610     MAC6="${mac_prefix}06"
611 }
612
613 ######################################################################
614
615 # Updating a disk image...
616
617 make_system_disk_access_function ()
618 {
619     eval "$1 () { call_func $1 \"\$SYSTEM_DISK_ACCESS_METHOD\" \"\$@\" ; }"
620 }
621
622 for i in \
623     mount unmount \
624     mkdir_p substitute_vars chmod chmod_reference \
625     is_directory is_file append_text_file append_text sed put ln_s grep \
626     command \
627     ; do
628     make_system_disk_access_function "diskimage_$i"
629 done
630
631 # setup the files from $BASE_TEMPLATES/, substituting any variables
632 # based on the config
633 copy_base_dir_substitute_templates ()
634 {
635     local dir="$1"
636
637     local d="$BASE_TEMPLATES/$dir"
638     [ -d "$d" ] || return 0
639
640     local f
641     for f in $(cd "$d" && find . \! -name '*~') ; do
642         f="${f#./}" # remove leading "./" for clarity
643         if [ -d "$d/$f" ]; then
644             diskimage_mkdir_p "/$f"
645         else 
646             diskimage_substitute_vars "$d/$f" "/$f"
647         fi
648         diskimage_chmod_reference "$d/$f" "/$f"
649     done
650 }
651
652 setup_base_hooks=
653
654 setup_base_ssh_keys ()
655 {
656     # this is needed as git doesn't store file permissions other
657     # than execute
658     # Note that we protect the wildcards from the local shell.
659     diskimage_chmod 600 "/etc/ssh/*key" "/root/.ssh/*"
660     diskimage_chmod 700 "/etc/ssh" "/root/.ssh" "/root"
661     if [ -r "$HOME/.ssh/id_rsa.pub" ]; then
662        echo "Adding $HOME/.ssh/id_rsa.pub to ssh authorized_keys"
663        diskimage_append_text_file "$HOME/.ssh/id_rsa.pub" "/root/.ssh/authorized_keys"
664     fi
665     if [ -r "$HOME/.ssh/id_dsa.pub" ]; then
666        echo "Adding $HOME/.ssh/id_dsa.pub to ssh authorized_keys"
667        diskimage_append_text_file "$HOME/.ssh/id_dsa.pub" "/root/.ssh/authorized_keys"
668     fi
669 }
670
671 register_hook setup_base_hooks setup_base_ssh_keys
672
673 setup_base_grub_conf ()
674 {
675     echo "Adjusting grub.conf"
676     local o="$EXTRA_KERNEL_OPTIONS" # For readability.
677     diskimage_sed "/boot/grub/grub.conf" \
678         -e "s/console=ttyS0,19200/console=ttyS0,115200/"  \
679         -e "s/ nodmraid//" -e "s/ nompath//"  \
680         -e "s/quiet/noapic divider=10${o:+ }${o}/g"
681 }
682
683 register_hook setup_base_hooks setup_base_grub_conf
684
685 setup_base()
686 {
687     local type="$1"
688
689     umask 022
690     echo "Copy base files"
691     copy_base_dir_substitute_templates "all"
692     if [ -n "$type" ] ; then
693         copy_base_dir_substitute_templates "$type"
694     fi
695
696     run_hooks setup_base_hooks
697 }
698
699 # setup various networking components
700 setup_network()
701 {
702     # This avoids doing anything when we're called from boot_base().
703     if [ -z "$hosts_file" ] ; then
704         echo "Skipping network-related setup"
705         return
706     fi
707
708     echo "Setting up networks"
709     diskimage_append_text_file "$hosts_file" "/etc/hosts"
710
711     echo "Setting up /etc/ctdb/nodes"
712     diskimage_mkdir_p "/etc/ctdb"
713     diskimage_put "$nodes_file" "/etc/ctdb/nodes"
714
715     [ "$WEBPROXY" = "" ] || {
716         diskimage_append_text "export http_proxy=$WEBPROXY" "/etc/bashrc"
717     }
718
719     if [ -n "$NFSSHARE" -a -n "$NFS_MOUNTPOINT" ] ; then
720         echo "Enabling nfs mount of $NFSSHARE"
721         diskimage_mkdir_p "$NFS_MOUNTPOINT"
722         diskimage_append_text "$NFSSHARE $NFS_MOUNTPOINT nfs intr" "/etc/fstab"
723     fi
724
725     diskimage_mkdir_p "/etc/yum.repos.d"
726     echo '@@@YUM_TEMPLATE@@@' | diskimage_substitute_vars - "/etc/yum.repos.d/autocluster.repo"
727 }
728
729 register_hook setup_base_hooks setup_network
730
731 setup_timezone() {
732     [ -z "$TIMEZONE" ] && {
733         [ -r /etc/timezone ] && {
734             TIMEZONE=`cat /etc/timezone`
735         }
736         [ -r /etc/sysconfig/clock ] && {
737             . /etc/sysconfig/clock
738             TIMEZONE="$ZONE"
739         }
740         TIMEZONE="${TIMEZONE// /_}"
741     }
742     [ -n "$TIMEZONE" ] || \
743         die "Unable to determine TIMEZONE - please set in config"
744 }
745
746 # substite a set of variables of the form @@XX@@ for the shell
747 # variables $XX in a file.
748 #
749 # Indirect variables @@@XX@@@ (3 ats) specify that the variable should
750 # contain a filename whose contents are substituted, with variable
751 # substitution applied to those contents.  If filename starts with '|'
752 # it is a command instead - however, quoting is extremely fragile.
753 substitute_vars() {(
754         infile="${1:-/dev/null}" # if empty then default to /dev/null
755         outfile="$2" # optional
756
757         instring=$(cat $infile)
758
759         # Handle any indirects by looping until nothing changes.
760         # However, only handle 10 levels of recursion.
761         count=0
762         while : ; do
763             outstring=$(_substitute_vars "$instring" "@@@")
764             [ $? -eq 0 ] || die "Failed to expand template $infile"
765
766             [ "$instring" = "$outstring" ] && break
767
768             count=$(($count + 1))
769             [ $count -lt 10 ] || \
770                 die "Recursion too deep in $infile - only 10 levels allowed!"
771
772             instring="$outstring"
773         done
774
775         # Now regular variables.
776         outstring=$(_substitute_vars "$instring" "@@")
777         [ $? -eq 0 ] || die "Failed to expand template $infile"
778
779         if [ -n "$outfile" ] ; then
780             echo "$outstring" > "$outfile"
781         else
782             echo "$outstring"
783         fi
784 )}
785
786
787 # Delimiter @@ means to substitute contents of variable.
788 # Delimiter @@@ means to substitute contents of file named by variable.
789 # @@@ supports leading '|' in variable value, which means to excute a
790 # command.
791 _substitute_vars() {(
792         instring="$1"
793         delimiter="${2:-@@}"
794
795         # Get the list of variables used in the template.  The grep
796         # gets rid of any blank lines and lines with extraneous '@'s
797         # next to template substitutions.
798         VARS=$(echo "$instring" |
799             sed -n -e "s#[^@]*${delimiter}\([A-Z0-9_][A-Z0-9_]*\)${delimiter}[^@]*#\1\n#gp" |
800             grep '^[A-Z0-9_][A-Z0-9_]*$' |
801             sort -u)
802
803         tmp=$(mktemp)
804         for v in $VARS; do
805             # variable variables are fun .....
806             [ "${!v+x}" ] || {
807                 rm -f $tmp
808                 die "No substitution given for ${delimiter}$v${delimiter} in $infile"
809             }
810             s=${!v}
811
812             if [ "$delimiter" = "@@@" ] ; then
813                 f=${s:-/dev/null}
814                 c="${f#|}" # Is is a command, signified by a leading '|'?
815                 if [ "$c" = "$f" ] ; then
816                     # No leading '|', cat file.
817                     s=$(cat -- "$f")
818                     [ $? -eq 0 ] || {
819                         rm -f $tmp
820                         die "Could not substitute contents of file $f"
821                     }
822                 else
823                     # Leading '|', execute command.
824                     # Quoting problems here - using eval "$c" doesn't help.
825                     s=$($c)
826                     [ $? -eq 0 ] || {
827                         rm -f $tmp
828                         die "Could not execute command $c"
829                     }
830                 fi
831             fi
832
833             # escape some pesky chars
834             # This first one can be too slow if done using a bash
835             # variable pattern subsitution.
836             s=$(echo -n "$s" | tr '\n' '\001' | sed -e 's/\o001/\\n/g')
837             s=${s//#/\\#}
838             s=${s//&/\\&}
839             echo "s#${delimiter}${v}${delimiter}#${s}#g"
840         done > $tmp
841
842         echo "$instring" | sed -f $tmp
843
844         rm -f $tmp
845 )}
846
847 check_command() {
848     which $1 > /dev/null || die "Please install $1 to continue"
849 }
850
851 # Set a variable if it isn't already set.  This allows environment
852 # variables to override default config settings.
853 defconf() {
854     local v="$1"
855     local e="$2"
856
857     [ "${!v+x}" ] || eval "$v=\"$e\""
858 }
859
860 load_config () {
861     local i
862
863     for i in "${installdir}/config.d/"*.defconf ; do
864         . "$i"
865     done
866 }
867
868 # Print the list of config variables defined in config.d/.
869 get_config_options () {( # sub-shell for local declaration of defconf()
870         local options=
871         defconf() { options="$options $1" ; }
872         load_config
873         echo $options
874 )}
875
876 # Produce a list of long options, suitable for use with getopt, that
877 # represent the config variables defined in config.d/.
878 getopt_config_options () {
879     local x=$(get_config_options | tr 'A-Z_' 'a-z-')
880     echo "${x// /:,}:"
881 }
882
883 # Unconditionally set the config variable associated with the given
884 # long option.
885 setconf_longopt () {
886     local longopt="$1"
887     local e="$2"
888
889     local v=$(echo "${longopt#--}" | tr 'a-z-' 'A-Z_')
890     # unset so defconf will set it
891     eval "unset $v"
892     defconf "$v" "$e"
893 }
894
895 # Dump all of the current config variables.
896 dump_config() {
897     local o
898     for o in $(get_config_options) ; do
899         echo "${o}=\"${!o}\""
900     done
901     exit 0
902 }
903
904 # $COLUMNS is set in interactive bash shells.  It probably isn't set
905 # in this shell, so let's set it if it isn't.
906 : ${COLUMNS:=$(stty size 2>/dev/null | sed -e 's@.* @@')}
907 : ${COLUMNS:=80}
908 export COLUMNS
909
910 # Print text assuming it starts after other text in $startcol and
911 # needs to wrap before $COLUMNS - 2.  Subsequent lines start at $startcol.
912 # Long "words" will extend past $COLUMNS - 2.
913 fill_text() {
914     local startcol="$1"
915     local text="$2"
916
917     local width=$(($COLUMNS - 2 - $startcol))
918     [ $width -lt 0 ] && width=$((78 - $startcol))
919
920     local out=""
921
922     local padding
923     if [ $startcol -gt 0 ] ; then
924         padding=$(printf "\n%${startcol}s" " ")
925     else
926         padding="
927 "
928     fi
929
930     while [ -n "$text" ] ; do
931         local orig="$text"
932
933         # If we already have output then arrange padding on the next line.
934         [ -n "$out" ] && out="${out}${padding}"
935
936         # Break the text at $width.
937         out="${out}${text:0:${width}}"
938         text="${text:${width}}"
939
940         # If we have left over text then the line break may be ugly,
941         # so let's check and try to break it on a space.
942         if [ -n "$text" ] ; then
943             # The 'x's stop us producing a special character like '(',
944             # ')' or '!'.  Yuck - there must be a better way.
945             if [ "x${text:0:1}" != "x " -a "x${text: -1:1}" != "x " ] ; then
946                 # We didn't break on a space.  Arrange for the
947                 # beginning of the broken "word" to appear on the next
948                 # line but not if it will make us loop infinitely.
949                 if [ "${orig}" != "${out##* }${text}" ] ; then
950                     text="${out##* }${text}"
951                     out="${out% *}"
952                 else
953                     # Hmmm, doing that would make us loop, so add the
954                     # rest of the word from the remainder of the text
955                     # to this line and let it extend past $COLUMNS - 2.
956                     out="${out}${text%% *}"
957                     if [ "${text# *}" != "$text" ] ; then
958                         # Remember the text after the next space for next time.
959                         text="${text# *}"
960                     else
961                         # No text after next space.
962                         text=""
963                     fi
964                 fi
965             else
966                 # We broke on a space.  If it will be at the beginning
967                 # of the next line then remove it.
968                 text="${text# }"
969             fi
970         fi
971     done
972
973     echo "$out"
974 }
975
976 # Display usage text, trying these approaches in order.
977 # 1. See if it all fits on one line before $COLUMNS - 2.
978 # 2. See if splitting before the default value and indenting it
979 #    to $startcol means that nothing passes $COLUMNS - 2.
980 # 3. Treat the message and default value as a string and just us fill_text()
981 #    to format it. 
982 usage_display_text () {
983     local startcol="$1"
984     local desc="$2"
985     local default="$3"
986     
987     local width=$(($COLUMNS - 2 - $startcol))
988     [ $width -lt 0 ] && width=$((78 - $startcol))
989
990     default="(default \"$default\")"
991
992     if [ $((${#desc} + 1 + ${#default})) -le $width ] ; then
993         echo "${desc} ${default}"
994     else
995         local padding=$(printf "%${startcol}s" " ")
996
997         if [ ${#desc} -lt $width -a ${#default} -lt $width ] ; then
998             echo "$desc"
999             echo "${padding}${default}"
1000         else
1001             fill_text $startcol "${desc} ${default}"
1002         fi
1003     fi
1004 }
1005
1006 # Display usage information for long config options.
1007 usage_smart_display () {( # sub-shell for local declaration of defconf()
1008         local startcol=33
1009
1010         defconf() {
1011             local local longopt=$(echo "$1" | tr 'A-Z_' 'a-z-')
1012
1013             printf "     --%-25s " "${longopt}=${3}"
1014
1015             usage_display_text $startcol "$4" "$2"
1016         }
1017
1018         "$@"
1019 )}
1020
1021
1022 # Display usage information for long config options.
1023 usage_config_options (){
1024     usage_smart_display load_config
1025 }
1026
1027 list_releases () {
1028     local releases=$(cd $installdir/releases && echo *.release)
1029     releases="${releases//.release}"
1030     releases="${releases// /\", \"}"
1031     echo "\"$releases\""
1032 }
1033
1034 with_release () {
1035     local release="$1"
1036     shift # subsequent args are passed to release file
1037
1038     # This simply loads an extra config file from $installdir/releases
1039     f="${installdir}/releases/${release}.release"
1040     if [ -r "$f" ] ; then
1041         . "$f"
1042     else
1043         f="${installdir}/releases/${release%%-*}.release"
1044         if [ -r "$f" ] ; then
1045             . "$f" "${release#*-}"
1046         else
1047             echo "Unknown release \"${release}\" specified to --with-release"
1048             printf "%-25s" "Supported releases are: "
1049             fill_text 25 "$(list_releases)"
1050             exit 1
1051         fi
1052     fi
1053
1054 }
1055
1056 has_public_addresses_DEFAULT ()
1057 {
1058     false
1059 }
1060
1061 # Build public address configuration.
1062 # * 1st public IP:  unless specified, last octet is $FIRSTIP + $PUBLIC_IP_OFFSET
1063 # * Excluded nodes: unless specified via comma-separated list of IP offsets,
1064 #                   nodes are excluded via their node types
1065 # * Number of public addresses per interface is either specified or $NUMNODES.
1066 make_public_addresses () {
1067     local firstip="${1:-$(($FIRSTIP + $PUBLIC_IP_OFFSET))}"
1068     local excluded_nodes="$2" 
1069     local num_addrs="${3:-${NUMNODES}}"
1070
1071     # For delimiting matches.
1072     excluded_nodes="${excluded_nodes:+,}${excluded_nodes}${excluded_nodes:+,}"
1073     # Avoid spaces
1074     excluded_nodes="${excluded_nodes// /}"
1075
1076     make_public_addresses_for_node ()
1077     {
1078         [ "$ctdb_node" = 1 ] || return 0
1079
1080         echo "[/etc/ctdb/public_addresses:${name}.${DOMAIN}]"
1081
1082         if [ -n "$excluded_nodes" -a \
1083             "${excluded_nodes/,${ip_offset},}" = "$excluded_nodes" ] ||
1084             ([ -z "$excluded_nodes" ] &&
1085                 call_func has_public_addresses "$node_type") ; then
1086
1087             local e i
1088             for e in $IPNET1 $IPNET2 ; do
1089                 for i in $(seq $firstip $(($firstip + $num_addrs - 1))) ; do
1090                     if [ $i -gt 254 ] ; then
1091                         die "make_public_addresses: octet > 254 - consider setting PUBLIC_IP_OFFSET"
1092                     fi
1093                     printf "\t${IPBASE}.${e}.${i}/24 eth${e}\n"
1094                 done
1095             done            
1096         fi
1097         echo 
1098     }
1099     hack_all_nodes_with make_public_addresses_for_node
1100 }
1101
1102 ######################################################################
1103
1104 post_config_hooks=
1105
1106 ######################################################################
1107
1108 load_config
1109
1110 ############################
1111 # parse command line options
1112 long_opts=$(getopt_config_options)
1113 getopt_output=$(getopt -n autocluster -o "c:e:E:xh" -l help,dump,with-release: -l "$long_opts" -- "$@")
1114 [ $? != 0 ] && usage
1115
1116 use_default_config=true
1117
1118 # We do 2 passes of the options.  The first time we just handle usage
1119 # and check whether -c is being used.
1120 eval set -- "$getopt_output"
1121 while true ; do
1122     case "$1" in
1123         -c) shift 2 ; use_default_config=false ;;
1124         -e) shift 2 ;;
1125         -E) shift 2 ;;
1126         --) shift ; break ;;
1127         --with-release) shift 2 ;; # Don't set use_default_config=false!!!
1128         --dump|-x) shift ;;
1129         -h|--help) usage ;; # Usage should be shown here for real defaults.
1130         --*) shift 2 ;; # Assume other long opts are valid and take an arg.
1131         *) usage ;; # shouldn't happen, so this is reasonable.
1132     esac
1133 done
1134
1135 config="./config"
1136 $use_default_config && [ -r "$config" ] && . "$config"
1137
1138 eval set -- "$getopt_output"
1139
1140 while true ; do
1141     case "$1" in
1142         # force at least ./local_file to avoid accidental file from $PATH
1143         -c) . "$(dirname $2)/$(basename $2)" ; shift 2 ;;
1144         -e) run_hooks post_config_hooks ; eval "$2" ; exit ;;
1145         -E) eval "$2" ; shift 2 ;;
1146         --with-release)
1147             with_release "$2"
1148             shift 2
1149             ;;
1150         -x) set -x; shift ;;
1151         --dump) run_hooks post_config_hooks ; dump_config ;;
1152         --) shift ; break ;;
1153         -h|--help) usage ;; # Redundant.
1154         --*)
1155             # Putting --opt1|opt2|... into a variable and having case
1156             # match against it as a pattern doesn't work.  The | is
1157             # part of shell syntax, so we need to do this.  Look away
1158             # now to stop your eyes from bleeding! :-)
1159             x=",${long_opts}" # Now each option is surrounded by , and :
1160             if [ "$x" != "${x#*,${1#--}:}" ] ; then
1161                 # Our option, $1, surrounded by , and : was in $x, so is legal.
1162                 setconf_longopt "$1" "$2"; shift 2
1163             else
1164                 usage
1165             fi
1166             ;;
1167         *) usage ;; # shouldn't happen, so this is reasonable.
1168     esac
1169 done
1170
1171 run_hooks post_config_hooks 
1172
1173 # catch errors
1174 set -e
1175 set -E
1176 trap 'es=$?; 
1177       echo ERROR: failed in function \"${FUNCNAME}\" at line ${LINENO} of ${BASH_SOURCE[0]} with code $es; 
1178       exit $es' ERR
1179
1180 # check for needed programs 
1181 check_command expect
1182 if [ "$SYSTEM_DISK_FORMAT" = "qcow2" ] ; then
1183     check_command $QEMU_NBD
1184     check_command nbd-client
1185 fi
1186
1187 [ $# -lt 1 ] && usage
1188
1189 command="$1"
1190 shift
1191
1192 case $command in
1193     create)
1194         type=$1
1195         shift
1196         case $type in
1197             base)
1198                 [ $# != 0 ] && usage
1199                 create_base
1200                 ;;
1201             cluster)
1202                 [ $# != 1 ] && usage
1203                 create_cluster "$1"
1204                 ;;
1205             node)
1206                 [ $# != 2 ] && usage
1207                 create_one_node "$1" "$2"
1208                 ;;
1209             *)
1210                 usage;
1211                 ;;
1212         esac
1213         ;;
1214     mount)
1215         [ $# != 1 ] && usage
1216         diskimage_mount "$1"
1217         ;;
1218     unmount)
1219         [ $# != 0 ] && usage
1220         diskimage_unmount
1221         ;;
1222     bootbase)
1223         boot_base;
1224         ;;
1225     testproxy)
1226         test_proxy;
1227         ;;
1228     *)
1229         usage;
1230         ;;
1231 esac